# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section free

Name:           jsr311-1.0-api
Version:        1.0
Release:        4%{?dist}
Epoch:          0
Summary:        JAX-RS: Java API for RESTful Web Services
License:        CDDL
Group:          Development/Libraries/Java
URL:            https://jsr311.dev.java.net/
# svn export https://svn.java.net/svn/jsr311~svn/tags/jsr311-api-1.0-FAB/jsr311-api jsr311-1.0-api
# tar czf ../SOURCES/jsr311-1.0-api.tgz jsr311-1.0-api/

Source0:        jsr311-1.0-api.tgz
Source1:        jsr311-settings.xml
Source2:        jsr311-jpp-depmap.xml

Patch0:         jsr311-1.0-pom-xml.patch
Provides:       jsr311 = %{epoch}:%{version}-%{release}
Provides:       jsr311 = 1.0
Provides:       jsr311-api = %{epoch}:%{version}-%{release}
Provides:       jsr311-api = 1.0
Provides:       jsr311_api
Provides:       jsr311_1_0_api

Buildarch:      noarch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant
BuildRequires:  concurrent
BuildRequires:  dtdparser
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven2-plugin-surefire-report
BuildRequires:  maven2-common-poms >= 1.0
BuildRequires:  maven-doxia
BuildRequires:  maven-doxia-sitetools
BuildRequires:  apache-commons-parent
BuildRequires:  junit
BuildRequires:  log4j

Requires(preun):  %{_sbindir}/update-alternatives
Requires(post):  %{_sbindir}/update-alternatives
Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Requires:  java >= 0:1.6.0

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif


%description
%{summary}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n jsr311-1.0-api
%patch0 -p0 -b .sav0

cp -p %{SOURCE1} settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Dmaven2.jpp.mode=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/jsr311-api-%{version}.jar \
          $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 target/jsr311-api-%{version}-sources.jar \
          $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-sources.jar
install -m 644 target/jsr311-api-%{version}-javadoc.jar \
          $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-javadoc.jar

(cd $RPM_BUILD_ROOT%{_javadir} \
    && ln -sf %{name}-%{version}.jar %{name}.jar )
(cd $RPM_BUILD_ROOT%{_javadir} \
    && ln -sf %{name}-%{version}-sources.jar %{name}-sources.jar )
(cd $RPM_BUILD_ROOT%{_javadir} \
    && ln -sf %{name}-%{version}-javadoc.jar %{name}-javadoc.jar )

touch $RPM_BUILD_ROOT%{_javadir}/jsr311.jar
touch $RPM_BUILD_ROOT%{_javadir}/jsr311-api.jar
touch $RPM_BUILD_ROOT%{_javadir}/jsr311_api.jar
touch $RPM_BUILD_ROOT%{_javadir}/jsr311_1_0_api.jar

# poms
%add_to_maven_depmap org.jsr311 jsr311 1.0 JPP %{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.pom

# javadoc
install -dm 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -pr target/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
(cd %{buildroot}%{_javadocdir} && ln -sf %{name}-%{version} %{name})

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif


%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%{_sbindir}/update-alternatives --install %{_javadir}/jsr311.jar jsr311 %{_javadir}/jsr311-1.0-api.jar 10100
%{_sbindir}/update-alternatives --install %{_javadir}/jsr311-api.jar jsr311-api %{_javadir}/jsr311-1.0-api.jar 10100
%{_sbindir}/update-alternatives --install %{_javadir}/jsr311_api.jar jsr311_api %{_javadir}/jsr311-1.0-api.jar 10100
%{_sbindir}/update-alternatives --install %{_javadir}/jsr311_1_0_api.jar jsr311_1_1_1_api %{_javadir}/jsr311-1.0-api.jar 10100
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%preun
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove jsr311 %{_javadir}/jsr311-1.0-api.jar
    %{_sbindir}/update-alternatives --remove jsr311-api %{_javadir}/jsr311-1.0-api.jar
    %{_sbindir}/update-alternatives --remove jsr311_api %{_javadir}/jsr311-1.0-api.jar
    %{_sbindir}/update-alternatives --remove jsr311_1_0_api %{_javadir}/jsr311-1.0-api.jar
fi

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root,-)
%doc README.txt
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar
%ghost %{_javadir}/jsr311.jar
%ghost %{_javadir}/jsr311-api.jar
%ghost %{_javadir}/jsr311_api.jar
%ghost %{_javadir}/jsr311_1_0_api.jar
%{_javadir}/%{name}-sources.jar
%{_javadir}/%{name}-%{version}-sources.jar
%{_javadir}/%{name}-javadoc.jar
%{_javadir}/%{name}-%{version}-javadoc.jar


%{_datadir}/maven2/poms/JPP.%{name}.pom
%{_mavendepmapfragdir}/%{name}
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Sun Jul 10 2011 Ralph Apel <r.apel@r-apel.de> 0:1.0-4
- Rename to jsr311-1.0-api
- Move javadoc jar to _javadir

* Mon Aug 10 2009 Yong Yang <yyang@redhat.com> 0:1.0-3
- Import from RHEL-4-EP5
- Rename to jsr311

* Wed Aug 05 2009 Yong Yang <yyang@redhat.com> 0:1.0-2
- Fix %{Summary}

* Mon Aug 03 2009 Yong Yang <yyang@redhat.com> 0:1.0-1
- First release
